#include <bits/stdc++.h>

using namespace std;

int kizar(long int n)
{

    int meddig=sqrt(n), jelenleg=0;

    for(long int i=1;i<=meddig;i++)
    {
        if(n%i==0 && n/i != i)
        {
            jelenleg=jelenleg^i;
            jelenleg=jelenleg^(n/i);
        }
        else if(n/i == i)
        {
            jelenleg=jelenleg^i;
        }
    }


    return jelenleg;
}




int main()
{

    long int n, k;
    cin>>n>>k;

    vector<long int> osztok(k);
    for(long int i=0;i<k;i++)
    {
        cin>>osztok.at(i);
    }

    long int szam;
    long int ertek;
    for(long int i=0;i<k;i++)
    {
        szam=osztok.at(i);

        cout<<kizar(szam)<<" ";

       /* ertek=osztoi.at(0);

        for(long int j=1;j<osztoi.size();j++)
        {
             ertek=ertek^osztoi.at(j);

        }
        cout<<ertek<<" ";

        */
    }






    return 0;
}